# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/api.ipynb.

# %% auto 0
__all__ = ['Client']

# %% ../nbs/api.ipynb 3
import requests
import json
from tqdm import tqdm
import os
import time
from urllib import request

# %% ../nbs/api.ipynb 4
class Client:
    "API client"
    def __init__(self):
        pass

    @staticmethod
    def downloadImagesFromManifest(manifest_url, output_dir, pos_start=1, pos_end=-1, sleep_time=0):
        # sleep_time = 0

        start = pos_start - 1
        end = pos_end

        df = requests.get(manifest_url).json()
        canvases = df["sequences"][0]["canvases"]

        for i in tqdm(range(len(canvases))):
            if i >= start and (end < 0 or i < end):
                pass
            else:
                continue

            res = canvases[i]["images"][0]["resource"]
            index = str(i+1).zfill(4)
            path = "{}/{}.jpg".format(output_dir, index)
            os.makedirs(os.path.dirname(path), exist_ok=True)
            url = canvases[i]["images"][0]["resource"]["@id"]
            time.sleep(sleep_time)
            request.urlretrieve(url, path)
